<script lang="ts">
  import type { IComponent } from "./interfaces/IComponent";
  import type { Area } from "./enums/Area";
  import { Theme } from "./enums/Theme";
  import { LayerType } from "./enums/LayerType";

  export interface IProfileComponentLayer extends IComponent {
    area?: Area;
    theme: Theme;
    label?: string;
    type: LayerType;
  }

  export let classes: string = "";
  export let label: string = "";
  export let theme: Theme;
  export let type: LayerType;

  let classNames: string[];

  $: classNames.push("font-jetbrains");

  $: {
    classNames = classes?.split(" ") ?? [];

    switch (theme) {
      case Theme.Dark:
        classNames.push(
          "bg-neutral-800/50",
          "border",
          "border-neutral-800",
          "text-white"
        );
        break;

      case Theme.Light:
        classNames.push(
          "bg-neutral-100",
          "border",
          "border-neutral-100",
          "text-neutral-800"
        );
        break;
    }

    switch (type) {
      case LayerType.Heading:
        classNames.push(
          "rounded-2xl",
          "py-4",
          "px-5",
          "text-4xl",
          "font-extrabold",
          "font-jetbrains",
          "text-center",
          "whitespace-nowrap"
        );
        break;

      case LayerType.Section:
        classNames.push(
          "rounded-3xl",
          "py-4",
          "px-5",
          "shadow-[0_25px_50px_-12px_rgba(0,0,0,0.1)]"
        );
        break;

      case LayerType.SectionAlt:
        classNames.push(
          "rounded-xl",
          "p-5",
          "shadow-[0_4px_4px_rgba(0,0,0,0.25)]"
        );

      case LayerType.Card:
        classNames.push(
          "rounded-xl",
          "p-4",
          "shadow-[0_4px_4px_rgba(0,0,0,0.25)]"
        );
        break;
    }
  }

  $: classNames = classNames;
</script>

{#if type == LayerType.Heading}
  <h1 class={classNames.join(" ")}>
    <slot>{label}</slot>
  </h1>
{:else}
  <article class={classNames.join(" ")}>
    <slot>{label}</slot>
  </article>
{/if}
